import Util from './util';
var OSS = require('ali-oss')

export default {

  /**
   * 创建随机字符串
   * @param num
   * @returns {string}
   */
  randomString(num) {
    const chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z']
    let res = ''
    for (let i = 0; i < num; i++) {
      var id = Math.ceil(Math.random() * 35)
      res += chars[id]
    }
    return res
  },

  /**
   * 创建oss客户端对象
   * @returns {*}
   */
  createOssClient(bucket) {
    return new Promise((resolve, reject) => {
      const client = new OSS({
        region: 'oss-cn-hangzhou',
        accessKeyId: 'LTAI4FyZj7RNejbzssiWFGKW',
        accessKeySecret: 'vEhYSgkxEwFHe5O2nRnzqUunXZjU9s',
        bucket: bucket
      })
      resolve(client)
    })
  },
  /**
   * 生成uuid
   */
  uuid() {
    var s = [];
    var hexDigits = "0123456789ABCDEF";
    for (var i = 0; i < 36; i++) {
      s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
    }
    s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
    s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
    s[8] = s[13] = s[18] = s[23] = "-";
    var uuid = s.join("").replace("-","");
    return uuid
  },

  /**
   * 文件上传
   * @param option 参考csdn: https://blog.csdn.net/qq_27626333/article/details/81463139
   */
  ossUploadFile(option) {
    const tempFile = option.tempFile
    const file = option.file
    const self = this
    
    return new Promise((resolve, reject) => {
      const extensionName = file.name.substr(file.name.indexOf('.')) // 文件扩展名
      const fileName = `${option.iProjectId}${option.sProjectNo}/${(option.uuid || self.uuid())}.jpg`

      console.log(option.uuid)
      // 执行上传
      self.createOssClient(option.bucket).then(client => {
        // 异步上传,返回数据
        resolve({
          fileName: file.name,
          fileUrl: fileName
        })
        // 上传处理
        // 分片上传文件
        client.multipartUpload(fileName, tempFile, {
            headers:{
                'Content-Type': 'image/jpg'
            },
          progress: function(p) {
            const e = {}
            e.percent = Math.floor(p * 100)
            // console.log('Progress: ' + p)
            // option.onProgress(e)
          }
        }).then((val) => {
          if (val.res.statusCode === 200) {
            console.log('seccess')
            // option.onSuccess(val)
            return val
          } else {
              console.log('error')
            // option.onError('上传失败')
          }
        }, err => {
            console.log(err)
        //   option.onError('上传失败')
          reject(err)
        })
      })
    })
  }
}
